org.apache.hc.core5.http.nio.support

## Class BasicAsyncServerExpectationDecorator

- java.lang.Object
- - org.apache.hc.core5.http.nio.support.BasicAsyncServerExpectationDecorator

- All Implemented Interfaces:
    AsyncDataConsumer, AsyncDataExchangeHandler, AsyncDataProducer, AsyncServerExchangeHandler, ResourceHolder

      public class BasicAsyncServerExpectationDecorator
      extends Object
      implements AsyncServerExchangeHandler

  `AsyncServerExchangeHandler` implementation that adds support for the Expect-Continue handshake to an existing `AsyncServerExchangeHandler`.
  Since:
    5.0

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `BasicAsyncServerExpectationDecorator(AsyncServerExchangeHandler handler)`
    `BasicAsyncServerExpectationDecorator(AsyncServerExchangeHandler handler, Callback<Exception> exceptionCallback)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `available()` Returns the number of bytes immediately available for output.
    `void` | `consume(ByteBuffer src)` Triggered to pass incoming data to the data consumer.
    `void` | `failed(Exception cause)` Triggered to signal a failure in data processing.
    `void` | `handleRequest(HttpRequest request, EntityDetails entityDetails, ResponseChannel responseChannel, HttpContext context)` Processes the actual HTTP request.
    `void` | `produce(DataStreamChannel channel)` Triggered to signal the ability of the underlying data channel to accept more data.
    `void` | `releaseResources()`
    `void` | `streamEnd(List<? extends Header> trailers)` Triggered to signal termination of the data stream.
    `void` | `updateCapacity(CapacityChannel capacityChannel)` Triggered to signal ability of the underlying data stream to receive data capacity update.
    `protected AsyncResponseProducer` | `verify(HttpRequest request, HttpContext context)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### BasicAsyncServerExpectationDecorator

          public BasicAsyncServerExpectationDecorator(AsyncServerExchangeHandler handler,
                                                      Callback<Exception> exceptionCallback)

    - #### BasicAsyncServerExpectationDecorator

          public BasicAsyncServerExpectationDecorator(AsyncServerExchangeHandler handler)

  - ### Method Detail

    - #### verify

          protected AsyncResponseProducer verify(HttpRequest request,
                                                 HttpContext context)
                                          throws IOException,
                                                 HttpException

      Throws:
        `IOException`
        `HttpException`

    - #### handleRequest

          public final void handleRequest(HttpRequest request,
                                          EntityDetails entityDetails,
                                          ResponseChannel responseChannel,
                                          HttpContext context)
                                   throws HttpException,
                                          IOException

      Description copied from interface: `AsyncServerExchangeHandler`
      Processes the actual HTTP request. The handler can choose to send response messages immediately inside the call or asynchronously at some later point.
      Specified by:
        `handleRequest` in interface `AsyncServerExchangeHandler`
      Parameters:
        `request` - the actual request.
        `entityDetails` - the request entity details or `null` if the request does not enclose an entity.
        `responseChannel` - the response channel.
        `context` - the actual execution context.
      Throws:
        `HttpException`
        `IOException`

    - #### updateCapacity

          public final void updateCapacity(CapacityChannel capacityChannel)
                                    throws IOException

      Description copied from interface: `AsyncDataConsumer`
      Triggered to signal ability of the underlying data stream to receive data capacity update. The data consumer can choose to write data immediately inside the call or asynchronously at some later point.
      Specified by:
        `updateCapacity` in interface `AsyncDataConsumer`
      Parameters:
        `capacityChannel` - the channel for capacity updates.
      Throws:
        `IOException`

    - #### consume

          public final void consume(ByteBuffer src)
                             throws IOException

      Description copied from interface: `AsyncDataConsumer`
      Triggered to pass incoming data to the data consumer. The consumer must consume the entire content of the data buffer. The consumer must stop incrementing its capacity on the capacity channel if it is unable to accept more data. Once the data consumer has handled accumulated data or allocated more intermediate storage it can update its capacity information on the capacity channel.
      Specified by:
        `consume` in interface `AsyncDataConsumer`
      Parameters:
        `src` - data source.
      Throws:
        `IOException`

    - #### streamEnd

          public final void streamEnd(List<? extends Header> trailers)
                               throws HttpException,
                                      IOException

      Description copied from interface: `AsyncDataConsumer`
      Triggered to signal termination of the data stream.
      Specified by:
        `streamEnd` in interface `AsyncDataConsumer`
      Parameters:
        `trailers` - data stream trailers.
      Throws:
        `HttpException`
        `IOException`

    - #### available

          public final int available()

      Description copied from interface: `AsyncDataProducer`
      Returns the number of bytes immediately available for output. This method can be used as a hint to control output events of the underlying I/O session.
      Specified by:
        `available` in interface `AsyncDataProducer`
      Returns:
        the number of bytes immediately available for output

    - #### produce

          public final void produce(DataStreamChannel channel)
                             throws IOException

      Description copied from interface: `AsyncDataProducer`
      Triggered to signal the ability of the underlying data channel to accept more data. The data producer can choose to write data immediately inside the call or asynchronously at some later point.
      Specified by:
        `produce` in interface `AsyncDataProducer`
      Parameters:
        `channel` - the data channel capable to accepting more data.
      Throws:
        `IOException`

    - #### failed

          public final void failed(Exception cause)

      Description copied from interface: `AsyncDataExchangeHandler`
      Triggered to signal a failure in data processing.
      Specified by:
        `failed` in interface `AsyncDataExchangeHandler`
      Parameters:
        `cause` - the cause of the failure.

    - #### releaseResources

          public final void releaseResources()

      Specified by:
        `releaseResources` in interface `ResourceHolder`

Copyright © 2005–2021 The Apache Software Foundation. All rights reserved.